function DfileConvert(filename)
%**************************************************************************
%Last update 5-25-2011
%
%Copyright (c) 2011, Hod Lipson and John Amend. 
%All rights reserved.
%
%Redistribution and use in source and binary forms, with or without 
%modification, are permitted provided that the following conditions are 
%met:
%
% * Redistributions of source code must retain the above copyright notice, 
%   this list of conditions and the following disclaimer.
%
% * Redistributions in binary form must reproduce the above copyright 
%   notice, this list of conditions and the following disclaimer in the 
%   documentation and/or other materials provided with the distribution.
%
% * Neither the name of the freeLoader nor the names of its contributors 
%   may be used to endorse or promote products derived from this software 
%   without specific prior written permission.
%
%THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS 
%"AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED 
%TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR 
%PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR 
%CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, 
%EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, 
%PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR 
%PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF 
%LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING 
%NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS 
%SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
%**************************************************************************

%% open the file
    filenametxt = strcat(filename,'.txt');
    F1 = fopen(filenametxt);
    
%% strip out the file header
    for i=1:5 
        fgetl(F1);        
    end
    
%% Load the data
    j=0; k=1;
    while j<1 
        dataTemp = str2num(fgetl(F1));        
        E = isempty(dataTemp);
        if E<1
            DataP1temp(k,:) = dataTemp; 
        else
            j=1; %reached the end of the file
        end
        k=k+1;
    end
    
 %% Convert mlbs to lbs and delete time stamp    
    col2 = DataP1temp(:,2);
    col3 = DataP1temp(:,3)*.001;
    
    Fdata=[col2,col3];  
    
 %% Trim the beginning and end of file if data is useless
 
    %trim beginning
    q=1;
    Trimflag=0;
    while Trimflag==0
        if (Fdata(q,1)<10 || Fdata(q,1)>1005)
            q=q+1;
            Trimflag =0;
        else
            Trimflag =1;
        end
    end    
    Fdata2 = Fdata(q:length(Fdata),:);
   
    %trim end    
    q=length(Fdata2);
    Trimflag=0;
    while Trimflag==0
        if (Fdata2(q,1)<10 || Fdata2(q,1)>1005)
            q=q-1;
            Trimflag =0;
        else
            Trimflag =1;
        end
    end    
    Ftrim = Fdata2(1:q,:);
 
 %% Convert encoder angle data to extension
 
    % report how many encoder clicks in each time step, fill nonsense values with -1
    D1 = Ftrim(:,1);
    D2 = D1;
    D2(1)=0;   
    for m=2:length(D1)        
        if (D1(m)>5 && D1(m-1)>5 && D1(m)<1005 && D1(m-1)<1005)
            D2(m) = abs(D1(m-1)-D1(m));
        else
            D2(m)=-1;
        end        
    end
    
    %find the average rotation per timestep
    summer=0;
    counter=0;
    for s=1:length(D2)
        if D2(s)>0
            summer=summer+D2(s);
            counter=counter+1; 
        end
    end
    rot_avg=summer/counter;
    
    %replace all unknown values with the average
    ii=find(D2==-1);
    for t=1:length(ii)
        D2(ii(t))=rot_avg;
    end

    %add the increments to make extension vector grow
    D3 = D2;
    for r=2:length(D2)
        D3(r) = D3(r-1)+D2(r);        
    end
    
    %Convert encoder clicks to extension 61440 clicks/in     
    D4 = D3./61440;
    Ftrim(:,1) = D4;
    
%% Trim any ramp up from the beginnign of the file by
% assuming tests start at 0,0 and a 2 lbf corresponds to .001" extension
    X = Ftrim(:,1);
    Y = Ftrim(:,2);

    idx=find(Y>=2); 
    k=idx(1);
    N=length(X);
    X=X(k:N)-X(k)+0.001;
    Y=Y(k:N);
    X=[0;X];
    Y=[0;Y];
    
    DataFinal = [X,Y];
    
%% Write the final data to a text file    

    finfile = strcat(filename,'_convert.txt');
    
    dlmwrite(finfile, DataFinal);
 
 
 
 
 
 
 
 
 
 
 
 
 